package com.menagerie.ophelia

import android.app.Activity
import android.app.Application
import android.os.Bundle
import android.util.Log
import androidx.activity.ComponentActivity
import androidx.activity.compose.setContent
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.Spacer
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.padding
import androidx.compose.foundation.lazy.LazyColumn
import androidx.compose.foundation.lazy.items
import androidx.compose.material3.ExperimentalMaterial3Api
import androidx.compose.material3.ListItem
import androidx.compose.material3.MaterialTheme
import androidx.compose.material3.Surface
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.runtime.livedata.observeAsState
import androidx.compose.ui.Modifier
import androidx.compose.ui.platform.LocalContext
import androidx.compose.ui.tooling.preview.Preview
import androidx.compose.ui.unit.dp
import androidx.lifecycle.viewmodel.compose.viewModel
import com.menagerie.ophelia.database.polycule.BioListViewModel
import com.menagerie.ophelia.database.polycule.PolyculeApplication
import com.menagerie.ophelia.database.polycule.PolyculeRepository
import com.menagerie.ophelia.database.polycule.entity.Bio
import com.menagerie.ophelia.ui.theme.OpheliaTheme

class MainActivity : ComponentActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContent {
            OpheliaTheme {
                Surface(
                    modifier = Modifier.fillMaxSize(),
                    color = MaterialTheme.colorScheme.error
                ) {
                    val repository = (application as PolyculeApplication).repository
                    Greeting("Android", repository)
                }
            }
        }
    }
}

@Composable
fun Greeting(name: String, repository: PolyculeRepository, modifier: Modifier = Modifier) {
    Log.d("Tawni", "Test")
    val mBioListViewModel: BioListViewModel = viewModel(
        factory = BioListViewModel.BioListViewModelFactory(repository)
    )


    val items = mBioListViewModel.allBios.observeAsState(listOf()).value



    Column(
        modifier = Modifier.padding(16.dp)
    ) {
        Text(text = "FUCKING FINAALLLLLLYY")
        Spacer(modifier = Modifier.padding(16.dp))
        BioList(list = items, mBioListViewModel = mBioListViewModel)
        Spacer(modifier = Modifier.padding(16.dp))
    }
}

@OptIn(ExperimentalMaterial3Api::class)
@Composable
fun BioList(
    list: List<Bio>,
    mBioListViewModel: BioListViewModel
) {
    Log.d("Test" ,"${list.size}")
    LazyColumn() {
        items(list) {bio ->

            ListItem(
                headlineText = {Text(text = bio.name)}
            )
        }
    }
}