package com.menagerie.ophelia.database.polycule

import androidx.lifecycle.LiveData
import androidx.lifecycle.ViewModel
import androidx.lifecycle.ViewModelProvider
import androidx.lifecycle.asLiveData
import androidx.lifecycle.viewModelScope
import com.menagerie.ophelia.database.polycule.entity.Bio
import kotlinx.coroutines.launch


class BioListViewModel(private val repository: PolyculeRepository) : ViewModel() {

    val allBios: LiveData<List<Bio>> = repository.getAllBios().asLiveData()

    fun insert(bio: Bio) = viewModelScope.launch {
        repository.upsertBio(bio)
    }

    class BioListViewModelFactory(
        private val repository: PolyculeRepository) :
        ViewModelProvider.Factory {
        override fun <T : ViewModel> create(modelClass: Class<T>): T {
            if (modelClass.isAssignableFrom(BioListViewModel::class.java)) {
                @Suppress("UNCHECKED_CAST")
                return BioListViewModel(repository) as T
            }
            throw IllegalArgumentException("Unknown ViewModel Class")
        }
    }
}