package com.menagerie.ophelia.database.polycule.entity

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.Query
import androidx.room.Update
import kotlinx.coroutines.flow.Flow

@Dao
abstract class BioDao {

    @Insert
    abstract suspend fun insert(newBio: Bio)

    @Update
    abstract suspend fun update(existingBio: Bio) : Int

    @Query("SELECT * FROM bio_table ORDER BY name ASC")
    abstract fun getAllAlphabetisedBios(): Flow<List<Bio>>

    @Query("SELECT * FROM bio_table")
    abstract fun getAllBios(): Flow<List<Bio>>

}